class point x_init =
    val mutable x = x_init
    method get_x = x
    method move d = x <- x + d
  end

let p = new point 7

class colored_point x (c : string) =
    inherit point x
    val c = c
    method color = c
  end

class intref (x_init:int) = 
    val mutable x = x_init
    method get = x
    method set y = x <- y
  end

class 'a ref x_init = 
    val mutable x = (x_init : 'a)
    method get = x
    method set y = x <- y
  end

class 'a sillycircle (c : 'a) =
    val mutable center = c
    method center = center
    method set_center c = center <- c
    method move = (center#move : int -> unit)
  end

class 'a circle (c : 'a) =
    constraint 'a = #point
    val mutable center = c
    method center = center
    method set_center c = center <- c
    method move = center#move

and 'a colored_circle c =
    constraint 'a = #colored_point
    inherit ('a) circle c
    method color = center#color
  end

class printable_point y as s =
    inherit point y
    method print = print_int s#get_x
  end

class printable_colored_point y c as self : 'selftype =
    inherit colored_point y c
    inherit printable_point y as super
    method print =
      print_string "(";
      super#print;
      print_string ", ";
      print_string (self#color);
      print_string ")"
  end

class functional_point y =
    val x = y
    method get_x = x
    method move d = {< x = x + d >}
  end

class virtual comparable () : 'a =
    virtual leq : 'a -> bool
  end

class int_comparable (x : int) =
    inherit comparable ()
    val x = x
    method x = x
    method leq p = x <= p#x
  end

class protected_point x_init as self =
    val mutable x = x_init
    method get_x = x
    method protected move d = x <- x + d
    method bump = self#move 1
  end

module type POINT = sig 
    class restricted_point (int) =
      val mutable x : int
      method get_x : int
      method protected move : int -> unit
      method bump : unit
   end 
  end

module Point : POINT = struct 
    class restricted_point x = inherit protected_point x end
  end

module type ABSPOINT = sig 
    class restricted_point (int) =
      method get_x : int
      method bump : unit
   end 
  end

module Abspoint : ABSPOINT = Point

class silly x y =
  val x = x
  val mutable y = y
  method get = (x,y)
end
